## dpkg 1.22.18ubuntu1

=== debian/changelog ===
dpkg (1.22.18ubuntu1) plucky; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Change native source version/format mismatch errors into warnings
      until the dust settles on Debian bug 737634 about override options.
    - Add DPKG_UNTRANSLATED_MESSAGES environment check so that higher-level
      tools can get untranslated dpkg terminal log messages while at the
      same time having translated debconf prompts.
    - Map unqualified package names of multiarch-same packages to the native
      arch instead of throwing an error, so that we don't break on upgrade
      when there are unqualified names stored in the dpkg trigger database.
    - Apply a workaround from mvo to consider ^rc packages as multiarch,
      during the dpkg consistency checks. (see LP: 1015567 and 1057367).
    - dpkg-gencontrol: Fix Package-Type override handling for ddeb support.
    - scripts/Dpkg/Vendor/Ubuntu.pm, scripts/dpkg-buildpackage.pl: set
      'nocheck' in build options by default on Ubuntu/riscv64.  Overridable
      in debian/rules with
      'DEB_BUILD_OPTIONS := $(filter-out nocheck,$(DEB_BUILD_OPTIONS))'.
    - dpkg-dev: Depend on lto-disabled-list.
    - dpkg-buildflags: Read package source names from lto-disabled-list,
      to build without lto optimizations. When adding a source package to the
      list, please also file a launchpad issue and tag it with 'lto'.
    - scripts/Dpkg/Vendor/Ubuntu.pm: set 'noudeb' build profile by
      default. Override this by exporting DEB_BUILD_PROFILE='!noudeb' which
      will be stripped, and thus building with udebs.
    - build: Switch default dpkg-deb compression from xz to zstd.
      Keep compressing dpkg.deb with xz to help bootstrapping on non-Ubuntu
      systems.
    - set default zstd compression level to 19
    - scripts/Dpkg/Vendor/Debian.pm: Always include "-fdebug-prefix-map"
      to build flags.  Map path to "/usr/src/PKGNAME-PKGVER" instead of
      ".", honouring the DWARF standard which prohibits relative paths
      in DW_AT_comp_dir.
    - scripts/{mk/buildflags.mk,t.mk}: Add support for DEB_BUILD_DEBUGPATH.
    - man/dpkg-buildflags.pod: Document new behaviour of "fdebugmap" and
      new DEB_BUILD_DEBUGPATH variable.
    - Disable -fstack-clash-protection on armhf since it causes crashes
    - dpkg-buildflags: Add a new feature "framepointer" in the "qa" area.
    - Turn on the use of frame pointers by default on 64bit architectures.
    - Update _FORTIFY_SOURCE documentation.
    - Update Dpkg_BuildFlags test case.
    - Fix debian/rules duplicate invocations of dh_builddeb
    - lib/dpkg/compress.c: clean up override of the default zstd compression
      level
    - dpkg-buildflags: Explicitly turn off hardening flags when requested.
    - Export environment variables DEB_BUILD_OS_RELEASE_ID, DEB_HOST_ARCH,
      DEB_SOURCE, and DEB_VERSION when including buildflags.mk (LP: #2070015)
    - buildflags: document RUSTFLAGS
    - buildflags: Always set RUSTFLAGS
    - tests: avoid failing under DEB_VENDOR != Debian
    - dpkg-buildflags: enable ELF package note metadata
    - buildflags: set origin of env vars for ELF package metadata
    - Export ELF_PACKAGE_METADATA for a build. Picked up by GCC and clang.
      Passing -specs explicitly can be dropped in a follow-up upload.
    - dpkg-buildflags: set RUSTFLAGS to influence the command line flags cargo
      will pass to rustc, and set the flags to include framepointers when the
      framepointer feature of the qa area is enabled.
    - Disable framepointer on ppc64el.
    - Disable framepointer on s390x, leaving only -mbackchain.
    - Add a note about different behaviour of dpkg-buildflags with respect to
      LTO on Ubuntu.
    - dpkg-buildpackage: Construct ELF_PACKAGE_METADATA, and set in the
      environment if not already set.  This setting is picked up by
      GCC and clang, passing a --package-metadata option the the linker.
    - Stop passing --specs for metadata information. It's too fragile
      and only works for GCC. Also introduces a lot of packaging delta.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 20 Mar 2025 10:46:37 +0100

dpkg (1.22.18) unstable; urgency=medium

  [ Guillem Jover ]
  * Perl modules:
    - Dpkg::OpenPGP::Backend::Sequoia: Add missing Dpkg::Gettext import.
      Thanks to Yuri Konotopov <ykonotopov@gnome.org>. Closes: #1099866
  * Packaging:
    - Bump Standards-Version to 4.7.2 (no changes needed).

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.
    - Update German scripts translation.

 -- Guillem Jover <guillem@debian.org>  Sun, 09 Mar 2025 19:00:01 +0100

dpkg (1.22.17) unstable; urgency=medium

  * Code internals:
    - libdpkg: Do not crash on missing sysuser or sysgroup system database
      files. Reported by Marc Haber <mh+debian-packages@zugschlus.de>.

 -- Guillem Jover <guillem@debian.org>  Fri, 07 Mar 2025 12:07:23 +0100

dpkg (1.22.16) unstable; urgency=medium

  [ Guillem Jover ]
  * Add support for native arch definition for chroots.
    Closes: #825385, #1020533
  * dpkg-db-keeper: Fix pathname in example dpkg.cfg snippet.
  * Portability:
    - start-stop-daemon: Move <compat.h> and <dpkg/macros.h> after OS and
      header setup macros.
  * Perl modules:
    - Dpkg::OpenPGP::Backend::GnuPG: Do not require cmdstore for backend
      command.
    - Dpkg::OpenPGP::Backend: Generalize has_verify_cmd().
    - Dpkg::OpenPGP::Backend: Support disabling cmd and cmdv via 'none' value.
    - Dpkg::OpenPGP::Backend::SOP: Add sopv support.
    - Dpkg::OpenPGP::Backend::GnuPG: Refactor newline workaround into a
      function.
    - Dpkg::OpenPGP::Backend::GnuPG: Do not add the newline workaround for
      gpg-sq.
    - Dpkg::OpenPGP::Backend::Sequoia: Add a hint about authorizing own keys.
    - Dpkg::OpenPGP::Backend::Sequoia: Refactor cmd and cmdv handling.
  * Documentation:
    - man: Remove trailing space. Closes: #1095542
    - doc: Remove trailing angle bracket.


=== debian/control ===
Source: dpkg
Section: admin
Priority: required
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
Uploaders: Guillem Jover <guillem@debian.org>
Homepage: https://wiki.debian.org/Teams/Dpkg
Vcs-Browser: https://git.dpkg.org/cgit/dpkg/dpkg.git
Vcs-Git: https://git.dpkg.org/git/dpkg/dpkg.git
Standards-Version: 4.7.2
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 debhelper (>= 13.10~),
 pkgconf,
# Version needed for ITS support.
 gettext (>= 0.19.7),
# Version needed for --porefs defaults, conditional addenda and mode=eof.
 po4a (>= 0.59),
 libmd-dev,
 zlib1g-dev,
 libbz2-dev,
# Version needed for multi-threaded decompressor support.
 liblzma-dev (>= 5.4.0),
# Version needed for the new streaming API.
 libzstd-dev (>= 1.4.0),
 libselinux1-dev [linux-any],
 libncurses-dev (>= 6.1+20180210),
# Needed for the functional test.
 bzip2 <!nocheck>,
# Version needed for multi-threaded decompressor support.
 xz-utils (>= 5.4.0) <!nocheck>,
# Needed for the functional test.
 zstd <!nocheck>,
# Needed for the author release process.
 git <pkg.dpkg.author-release>,
 ca-certificates <pkg.dpkg.author-release>,
 libmodule-build-perl <pkg.dpkg.author-release>,
# Needed for the test suite in author mode.
 fakeroot <pkg.dpkg.author-testing>,
 sq <pkg.dpkg.author-testing>,
 sqop <pkg.dpkg.author-testing>,
 sqopv <pkg.dpkg.author-testing>,
 rsop <pkg.dpkg.author-testing>,
 rsopv <pkg.dpkg.author-testing>,
 gosop <pkg.dpkg.author-testing>,
 gpg-sq <pkg.dpkg.author-testing>,
 gpgv-sq <pkg.dpkg.author-testing>,
 gnupg <pkg.dpkg.author-testing>,
 cppcheck <pkg.dpkg.author-testing>,
 shellcheck <pkg.dpkg.author-testing>,
 aspell <pkg.dpkg.author-testing>,
 aspell-en <pkg.dpkg.author-testing>,
 codespell <pkg.dpkg.author-testing>,
 i18nspector <pkg.dpkg.author-testing>,
 libtest-minimumversion-perl <pkg.dpkg.author-testing>,
 libtest-perl-critic-perl <pkg.dpkg.author-testing>,
 libtest-pod-coverage-perl <pkg.dpkg.author-testing>,
 libtest-pod-perl <pkg.dpkg.author-testing>,
 libtest-spelling-perl <pkg.dpkg.author-testing>,
 libtest-strict-perl <pkg.dpkg.author-testing>,
 libtest-synopsis-perl <pkg.dpkg.author-testing>,
# Needed for code coverage reports.
 lcov <pkg.dpkg.code-coverage>,
 libdevel-cover-perl <pkg.dpkg.code-coverage>,

Package: dpkg
Architecture: any
Multi-Arch: foreign
Essential: yes
Pre-Depends:
 ${shlibs:Depends},
Depends:
 ${misc:Depends},
# Version needed for --clamp-mtime in dpkg-deb -b.
 tar (>= 1.28-1),
Suggests:
 apt,
 debsig-verify,
Breaks:
# Due to --status-fd not duplicating output.
 libapt-pkg5.0 (<< 1.7~b),
# Due to s-s-d requiring secure usage of --pidfile.
 lsb-base (<< 10.2019031300),
Description: Debian package management system
 This package provides the low-level infrastructure for handling the
 installation and removal of Debian software packages.
 .
 For Debian package development tools, install dpkg-dev.

Package: libdpkg-dev
Section: libdevel
Priority: optional
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 libmd-dev,
 zlib1g-dev,
# Version needed for multi-threaded decompressor support.
 liblzma-dev (>= 5.4.0),
# Version needed for the new streaming API.
 libzstd-dev (>= 1.4.0),
 libbz2-dev,
Description: Debian package management static library
 This package provides the header files and static library necessary to
 develop software using libdpkg, the same library used internally by dpkg.
 .
 Note though, that the API is to be considered volatile, and might change
 at any time, use at your own risk.

Package: dpkg-dev
Section: utils
Priority: optional
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${perl:Depends},
 libdpkg-perl (= ${source:Version}),
# Version needed for --clamp-mtime.
 tar (>= 1.28-1),
 bzip2,
# Version needed for multi-threaded decompressor support.
 xz-utils (>= 5.4.0),
# Version needed for git-style diff support.
 patch (>= 2.7),
 make,
 binutils,
 lto-disabled-list,
Recommends:
 build-essential,
 gcc | c-compiler,
 fakeroot,
 sq | sqop | rsop | gosop | pgpainless-cli | gpg-sq | gnupg,
 sq | sqopv | rsopv | sopv | gosop | pgpainless-cli | gpgv-sq | gpgv,
# Used by dpkg-mergechangelogs.
 libalgorithm-merge-perl,
Suggests:
 debian-keyring,
Breaks:
# Force R³ support, w/o requiring debhelper users to depend on dpkg-dev.
 debhelper (<< 10.10.1~),
# Uses new sq features, w/o requiring a hard dependency on sq.
 sq (<< 0.40.0~),
# Uses required SOP features, w/o requiring a hard dependency on sqop.
 sqop (<< 0.27.2~),
# Uses required SOP features, w/o requiring a hard dependency on rsop.
 rsop (<< 0.4.0~),
# Uses required SOP features, w/o requiring a hard dependency on gosop.
 gosop (<< 1.1.0~),
# Uses required SOP features, w/o requiring a hard dependency on pgpainless.
 pgpainless-cli (<< 1.3.13~),
 libsop-java-java (<< 4.0.7~),
Provides:
 dpkg-build-api (= 0),
 dpkg-build-api (= 1),
Description: Debian package development tools
 This package provides the development tools (including dpkg-source)
 required to unpack, build and upload Debian source packages.
 .
 Most Debian source packages will require additional tools to build;
 for example, most packages need make and the C compiler gcc.

Package: libdpkg-perl
Section: perl
Priority: optional
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${perl:Depends},
# Version needed for arch tuples.
 dpkg (>= 1.18.11),
Recommends:
# Used by Dpkg::File.
 libfile-fcntllock-perl,
# Used by Dpkg::Gettext.
 liblocale-gettext-perl,
 bzip2,
# Version needed for multi-threaded decompressor support.
 xz-utils (>= 5.4.0),
Suggests:
 debian-keyring,
 sq | sqop | rsop | gosop | pgpainless-cli | gpg-sq | gnupg,
 sq | sqopv | rsopv | sopv | gosop | pgpainless-cli | gpgv-sq | gpgv,
 gcc | c-compiler,
 binutils,
 patch,
# Used (if available) by Dpkg::Source::Package::V2.
 sensible-utils,
# Needed by Dpkg::Source::Package::V3::Git
 git,
# Needed by Dpkg::Source::Package::V3::Bzr
 bzr,
Breaks:
# Uses the private Dpkg::Shlibs::SymbolFile module with no API stability
# guarantees! Which obviously broke with 1.19.0.
 pkg-kde-tools (<< 0.15.28~),
# Uses Dpkg::Compression::Process imported from Dpkg::Source::Package in
# versions prior to 1.19.0.
 dgit (<< 3.13~),
# Uses new sq features, w/o requiring a hard dependency on sq.
 sq (<< 0.40.0~),
# Uses required SOP features, w/o requiring a hard dependency on sqop.
 sqop (<< 0.27.2~),
# Uses required SOP features, w/o requiring a hard dependency on rsop.
 rsop (<< 0.4.0~),
# Uses required SOP features, w/o requiring a hard dependency on gosop.
 gosop (<< 1.1.0~),
# Uses required SOP features, w/o requiring a hard dependency on pgpainless.
 pgpainless-cli (<< 1.3.13~),
 libsop-java-java (<< 4.0.7~),
Description: Dpkg perl modules
 This package provides the perl modules used by the scripts
 in dpkg-dev. They cover a wide range of functionality. Among them
 there are the following public modules:
 .
  - Dpkg: core variables
  - Dpkg::Arch: architecture handling functions
  - Dpkg::BuildFlags: set, modify and query compilation build flags
  - Dpkg::BuildInfo: build information functions
  - Dpkg::BuildOptions: parse and manipulate DEB_BUILD_OPTIONS
  - Dpkg::BuildProfiles: parse and manipulate build profiles
  - Dpkg::Changelog: parse changelogs
  - Dpkg::Changelog::Entry: represents a changelog entry
  - Dpkg::Changelog::Parse: generic changelog parser for dpkg-parsechangelog
  - Dpkg::Checksums: generate and parse checksums
  - Dpkg::Compression: simple database of available compression methods
  - Dpkg::Compression::FileHandle: transparently (de)compress files
  - Dpkg::Compression::Process: wrapper around compression tools
  - Dpkg::Conf: parse dpkg configuration files
  - Dpkg::Control: parse and manipulate Debian control information
    (.dsc, .changes, Packages/Sources entries, etc.)
  - Dpkg::Control::Changelog: represent fields output by dpkg-parsechangelog
  - Dpkg::Control::Fields: manage (list of known) control fields
  - Dpkg::Control::Hash: parse and manipulate a block of RFC822-like fields
  - Dpkg::Control::Info: parse files like debian/control
  - Dpkg::Control::Tests: parse files like debian/tests/control
  - Dpkg::Control::Tests::Entry: represents a debian/tests/control stanza
  - Dpkg::Deps: parse and manipulate dependencies
  - Dpkg::Deps::Simple: represents a single dependency statement
  - Dpkg::Deps::Multiple: base module to represent multiple dependencies
  - Dpkg::Deps::Union: list of unrelated dependencies
  - Dpkg::Deps::AND: list of AND dependencies
  - Dpkg::Deps::OR: list of OR dependencies
  - Dpkg::Deps::KnownFacts: list of installed and virtual packages
  - Dpkg::Exit: push, pop and run exit handlers
  - Dpkg::Gettext: wrapper around Locale::gettext
  - Dpkg::IPC: spawn sub-processes and feed/retrieve data
  - Dpkg::Index: collections of Dpkg::Control (Packages/Sources files for
    example)
  - Dpkg::Interface::Storable: base object serializer
  - Dpkg::Path: common path handling functions
  - Dpkg::Source::Format: manipulate debian/source/format files
  - Dpkg::Source::Package: extract Debian source packages
  - Dpkg::Substvars: substitute variables in strings
  - Dpkg::Vendor: identify current distribution vendor
  - Dpkg::Version: parse and manipulate Debian package versions
 .
 All the packages listed in Suggests or Recommends are used by some of the
 modules.

Package: dselect
Priority: optional
Architecture: any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Suggests:
 libdpkg-perl,
 perl,
Description: Debian package management front-end
 dselect is a high-level interface for managing the installation and
 removal of Debian software packages.
 .
 Many users find dselect intimidating and new users may prefer to use
 apt-based user interfaces.

## dpkg 1.22.18ubuntu2

=== tests/t-breaks-essential/Makefile ===
TESTS_DEB := lib-a-0 lib-a-1 pkg-b

include ../Test.mk

DPKG_OPTIONS += --auto-deconfigure

test-case:
	$(DPKG_INSTALL) lib-a-0.deb
	$(DPKG_INSTALL) pkg-b.deb lib-a-1.deb

test-clean:
	$(DPKG_PURGE) pkg-b
	$(DPKG_PURGE) --force-remove-essential lib-a

=== tests/t-control-no-arch/Makefile ===
include ../Test.mk

test-case:
	# test building package with missing Architecture field.
	! $(DPKG_BUILD_DEB) pkg-no-arch

	# build bogus packages
	$(DPKG_BUILD_DEB) --no-check pkg-no-arch

	# test handling of package without the Architecture field
	! $(DPKG_INSTALL) pkg-no-arch.deb
	$(call pkg_is_not_installed,pkg-no-arch)
	# these ancient/bogus packages need to be forced now
	$(DPKG_INSTALL) --force-architecture pkg-no-arch.deb
	$(call pkg_is_installed,pkg-no-arch)
	! $(call stdout_has,$(DPKG_QUERY) --status pkg-no-arch,^Architecture:)
	$(DPKG_PURGE) pkg-no-arch
	# Clear the available file to avoid missing Architecture warnings
	$(BEROOT) $(DPKG) --clear-avail

test-clean:
	rm -f pkg-no-arch.deb

=== tests/t-option-dry-run/Makefile ===
TESTS_DEB := pkg-normal

include ../Test.mk

test-case:
	# Make sure the package is not there
	$(DPKG_PURGE) pkg-normal
	
	# Simulate unpacking a package
	$(DPKG_UNPACK) --dry-run pkg-normal.deb
	$(call pkg_is_not_installed,pkg-normal)
	$(DPKG_INSTALL) --dry-run pkg-normal.deb
	$(call pkg_is_not_installed,pkg-normal)
	
	$(DPKG_UNPACK) pkg-normal.deb
	
	# Simulate configuring a package
	$(DPKG_CONFIGURE) --dry-run pkg-normal
	$(call pkg_status_is,pkg-normal,install ok unpacked)
	
	$(DPKG_CONFIGURE) pkg-normal
	
	# Simulate removing and purging a package
	$(DPKG_REMOVE) --dry-run pkg-normal
	$(call pkg_is_installed,pkg-normal)
	$(DPKG_PURGE) --dry-run pkg-normal
	$(call pkg_is_installed,pkg-normal)
	
	# XXX: Complete

test-clean:
	$(DPKG_PURGE) pkg-normal

=== tests/t-switch-symlink-abs-to-dir/Makefile ===
TESTS_DEB := pkg-dir-real pkg-dir-symlink-0 pkg-dir-symlink-1

include ../Test.mk

build-hook:
	ln -sf test-dir pkg-dir-symlink-0/test-symlink

clean-hook:
	$(RM) pkg-dir-symlink-0/test-symlink

test-case:
	$(DPKG_INSTALL) pkg-dir-real.deb

	$(DPKG_INSTALL) pkg-dir-symlink-0.deb
	test -h "$(DPKG_INSTDIR)/test-symlink"

	$(DPKG_INSTALL) pkg-dir-symlink-1.deb
	! test -h "$(DPKG_INSTDIR)/test-symlink"
	test -d "$(DPKG_INSTDIR)/test-symlink"

	$(DPKG_PURGE) pkg-dir-symlink
	! test -e "$(DPKG_INSTDIR)/test-symlink"

	$(DPKG_PURGE) pkg-dir-real

test-clean:
	$(DPKG_PURGE) pkg-dir-symlink
	$(DPKG_PURGE) pkg-dir-real

=== tests/t-triggers/Makefile ===
TESTS_DEB := pkg-triggers pkg-triggers-await pkg-triggers-noawait \
             pkg-trig-file pkg-trig-explicit pkg-trig-cmd

include ../Test.mk

TEST_CASES += test-trigger-file
TEST_CASES += test-trigger-explicit
TEST_CASES += test-trigger-cmd
TEST_CASES += test-trigger-await-file
TEST_CASES += test-trigger-await-cmd
TEST_CASES += test-trigger-noawait-file
TEST_CASES += test-trigger-noawait-explicit
TEST_CASES += test-trigger-noawait-cmd
TEST_CASES += test-internal-db

test-case: $(TEST_CASES)

test-trigger-file test-trigger-await-file:
	if [ "$@" = "test-trigger-file" ]; then \
	  $(DPKG_UNPACK) pkg-triggers.deb; \
	else \
	  $(DPKG_UNPACK) pkg-triggers-await.deb; \
	fi
	$(BEROOT) rm -f "$(DPKG_INSTDIR)/a-trigger-ok" "$(DPKG_INSTDIR)/triggers/ok"
	# When unpacked, triggers are not active
	$(DPKG_INSTALL) --no-triggers pkg-trig-file.deb
	$(call pkg_is_installed,pkg-trig-file)
	$(call pkg_status_is,pkg-triggers,install ok unpacked)
	$(call pkg_field_is,pkg-triggers,Triggers-Pending,)
	! test -f "$(DPKG_INSTDIR)/triggers/ok"
	$(DPKG_CONFIGURE) --no-triggers pkg-triggers
	$(call pkg_is_installed,pkg-triggers)
	! test -f "$(DPKG_INSTDIR)/triggers/ok"
	# When installed, triggers can be activated
	$(DPKG_INSTALL) --no-triggers pkg-trig-file.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_field_is,pkg-triggers,Triggers-Pending, /triggers)
	$(call pkg_status_is,pkg-trig-file,install ok triggers-awaited)
	$(BEROOT) $(DPKG) --triggers-only pkg-triggers
	$(call pkg_is_installed,pkg-triggers)
	$(call pkg_is_installed,pkg-trig-file)
	test -f "$(DPKG_INSTDIR)/triggers/ok" && $(BEROOT) rm -f "$(DPKG_INSTDIR)/triggers/ok"
	# Try other ways to run the triggers
	$(DPKG_INSTALL) --no-triggers pkg-trig-file.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_status_is,pkg-trig-file,install ok triggers-awaited)
	$(BEROOT) $(DPKG) --triggers-only --pending
	$(call pkg_is_installed,pkg-trig-file)
	$(call pkg_is_installed,pkg-triggers)
	test -f "$(DPKG_INSTDIR)/triggers/ok" && $(BEROOT) rm -f "$(DPKG_INSTDIR)/triggers/ok"
	# Again
	$(DPKG_INSTALL) --no-triggers pkg-trig-file.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_status_is,pkg-trig-file,install ok triggers-awaited)
	$(DPKG_CONFIGURE) --pending
	$(call pkg_is_installed,pkg-trig-file)
	$(call pkg_is_installed,pkg-triggers)
	test -f "$(DPKG_INSTDIR)/triggers/ok" && $(BEROOT) rm -f "$(DPKG_INSTDIR)/triggers/ok"
	# Again, but we're unpacking instead of installing
	$(DPKG_UNPACK) --no-triggers pkg-trig-file.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_status_is,pkg-trig-file,install ok unpacked)
	$(DPKG_CONFIGURE) pkg-trig-file
	# TODO: Remove ifdef during dpkg 1.18.x cycle, after the apt
	# workaround has been reverted.
ifdef DPKG_HAS_CONFIGURE_WITH_IMPLICIT_TRIGGER_PENDING
	$(call pkg_status_is,pkg-trig-file,install ok triggers-awaited)
	$(BEROOT) $(DPKG) --triggers-only pkg-triggers
endif
	$(call pkg_is_installed,pkg-trig-file)
	$(call pkg_is_installed,pkg-triggers)
	test -f "$(DPKG_INSTDIR)/triggers/ok" && $(BEROOT) rm -f "$(DPKG_INSTDIR)/triggers/ok"
	# Cleanup
	$(DPKG_PURGE) pkg-triggers
	$(DPKG_PURGE) pkg-trig-file

test-trigger-noawait-file:
	$(DPKG_UNPACK) pkg-triggers-noawait.deb
	$(BEROOT) rm -f "$(DPKG_INSTDIR)/a-trigger-ok" "$(DPKG_INSTDIR)/triggers/ok"
	# When unpacked, triggers are not active
	$(DPKG_INSTALL) --no-triggers pkg-trig-file.deb
	$(call pkg_is_installed,pkg-trig-file)
	$(call pkg_status_is,pkg-triggers,install ok unpacked)
	$(call pkg_field_is,pkg-triggers,Triggers-Pending,)
	! test -f "$(DPKG_INSTDIR)/triggers/ok"
	$(DPKG_CONFIGURE) --no-triggers pkg-triggers
	$(call pkg_is_installed,pkg-triggers)
	! test -f "$(DPKG_INSTDIR)/triggers/ok"
	# When installed, triggers can be activated
	$(DPKG_INSTALL) --no-triggers pkg-trig-file.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_field_is,pkg-triggers,Triggers-Pending, /triggers)
	$(call pkg_is_installed,pkg-trig-file)
	$(BEROOT) $(DPKG) --triggers-only pkg-triggers
	$(call pkg_is_installed,pkg-triggers)
	test -f "$(DPKG_INSTDIR)/triggers/ok" && $(BEROOT) rm -f "$(DPKG_INSTDIR)/triggers/ok"
	# Try other ways to run the triggers
	$(DPKG_INSTALL) --no-triggers pkg-trig-file.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_is_installed,pkg-trig-file)
	$(BEROOT) $(DPKG) --triggers-only --pending
	$(call pkg_is_installed,pkg-triggers)
	test -f "$(DPKG_INSTDIR)/triggers/ok" && $(BEROOT) rm -f "$(DPKG_INSTDIR)/triggers/ok"
	# Again
	$(DPKG_INSTALL) --no-triggers pkg-trig-file.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_is_installed,pkg-trig-file)
	$(DPKG_CONFIGURE) --pending
	$(call pkg_is_installed,pkg-trig-file)
	$(call pkg_is_installed,pkg-triggers)
	test -f "$(DPKG_INSTDIR)/triggers/ok" && $(BEROOT) rm -f "$(DPKG_INSTDIR)/triggers/ok"
	# Again, but we're unpacking instead of installing
	$(DPKG_UNPACK) --no-triggers pkg-trig-file.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_status_is,pkg-trig-file,install ok unpacked)
	$(DPKG_CONFIGURE) --no-triggers pkg-trig-file
	$(call pkg_is_installed,pkg-trig-file)
	$(BEROOT) $(DPKG) --triggers-only pkg-triggers
	$(call pkg_is_installed,pkg-triggers)
	test -f "$(DPKG_INSTDIR)/triggers/ok" && $(BEROOT) rm -f "$(DPKG_INSTDIR)/triggers/ok"
	# Cleanup
	$(DPKG_PURGE) pkg-triggers
	$(DPKG_PURGE) pkg-trig-file

test-trigger-explicit:
	$(DPKG_UNPACK) pkg-triggers.deb
	$(BEROOT) rm -f "$(DPKG_INSTDIR)/a-trigger-ok" "$(DPKG_INSTDIR)/triggers/ok"
	# When unpacked, triggers are not active
	$(DPKG_INSTALL) --no-triggers pkg-trig-explicit.deb
	$(call pkg_is_installed,pkg-trig-explicit)
	$(call pkg_status_is,pkg-triggers,install ok unpacked)
	$(call pkg_field_is,pkg-triggers,Triggers-Pending,)
	! test -f "$(DPKG_INSTDIR)/a-trigger-ok"
	$(DPKG_CONFIGURE) --no-triggers pkg-triggers
	$(call pkg_is_installed,pkg-triggers)
	! test -f "$(DPKG_INSTDIR)/a-trigger-ok"
	# When installed, triggers can be activated
	$(DPKG_INSTALL) --no-triggers pkg-trig-explicit.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_field_is,pkg-triggers,Triggers-Pending, a-trigger)
	$(call pkg_status_is,pkg-trig-explicit,install ok triggers-awaited)
	$(BEROOT) $(DPKG) --triggers-only pkg-triggers
	$(call pkg_is_installed,pkg-triggers)
	$(call pkg_is_installed,pkg-trig-explicit)
	test -f "$(DPKG_INSTDIR)/a-trigger-ok" && $(BEROOT) rm -f "$(DPKG_INSTDIR)/a-trigger-ok"
	# Try other ways to run the triggers
	$(DPKG_INSTALL) --no-triggers pkg-trig-explicit.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_status_is,pkg-trig-explicit,install ok triggers-awaited)
	$(BEROOT) $(DPKG) --triggers-only --pending
	$(call pkg_is_installed,pkg-trig-explicit)
	$(call pkg_is_installed,pkg-triggers)
	test -f "$(DPKG_INSTDIR)/a-trigger-ok" && $(BEROOT) rm -f "$(DPKG_INSTDIR)/a-trigger-ok"
	# Again
	$(DPKG_INSTALL) --no-triggers pkg-trig-explicit.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_status_is,pkg-trig-explicit,install ok triggers-awaited)
	$(DPKG_CONFIGURE) --pending
	$(call pkg_is_installed,pkg-trig-explicit)
	$(call pkg_is_installed,pkg-triggers)
	test -f "$(DPKG_INSTDIR)/a-trigger-ok" && $(BEROOT) rm -f "$(DPKG_INSTDIR)/a-trigger-ok"
	# Again, but we're unpacking instead of installing
	$(DPKG_UNPACK) --no-triggers pkg-trig-explicit.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_status_is,pkg-trig-explicit,install ok unpacked)
	$(DPKG_CONFIGURE) pkg-trig-explicit
	$(call pkg_is_installed,pkg-trig-explicit)
	$(call pkg_is_installed,pkg-triggers)
	test -f "$(DPKG_INSTDIR)/a-trigger-ok" && $(BEROOT) rm -f "$(DPKG_INSTDIR)/a-trigger-ok"
	# Verify the trigger is activated on each status change
	$(DPKG_UNPACK) --no-triggers pkg-trig-explicit.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_status_is,pkg-trig-explicit,install ok unpacked)
	$(call pkg_field_is,pkg-trig-explicit,Triggers-Awaited, pkg-triggers)
	$(BEROOT) $(DPKG) --triggers-only pkg-triggers
	$(call pkg_is_installed,pkg-triggers)
	$(call pkg_field_is,pkg-trig-explicit,Triggers-Awaited,)
	test -f "$(DPKG_INSTDIR)/a-trigger-ok" && $(BEROOT) rm -f "$(DPKG_INSTDIR)/a-trigger-ok"
	$(DPKG_CONFIGURE) --no-triggers pkg-trig-explicit
	$(call pkg_status_is,pkg-trig-explicit,install ok triggers-awaited)
	$(call pkg_field_is,pkg-trig-explicit,Triggers-Awaited, pkg-triggers)
	$(BEROOT) $(DPKG) --triggers-only pkg-triggers
	$(call pkg_is_installed,pkg-trig-explicit)
	$(call pkg_is_installed,pkg-triggers)
	# Cleanup
	$(DPKG_PURGE) pkg-triggers
	$(DPKG_PURGE) pkg-trig-explicit

test-trigger-noawait-explicit:
	$(DPKG_INSTALL) pkg-triggers-noawait.deb
	$(BEROOT) rm -f "$(DPKG_INSTDIR)/a-trigger-ok" "$(DPKG_INSTDIR)/triggers/ok"
	# When installed, triggers can be activated
	$(DPKG_INSTALL) --no-triggers pkg-trig-explicit.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_field_is,pkg-triggers,Triggers-Pending, a-trigger)
	$(call pkg_is_installed,pkg-trig-explicit)
	$(BEROOT) $(DPKG) --triggers-only pkg-triggers
	$(call pkg_is_installed,pkg-triggers)
	test -f "$(DPKG_INSTDIR)/a-trigger-ok" && $(BEROOT) rm -f "$(DPKG_INSTDIR)/a-trigger-ok"
	# Again, but we're unpacking instead of installing
	$(DPKG_UNPACK) --no-triggers pkg-trig-explicit.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_status_is,pkg-trig-explicit,install ok unpacked)
	$(call pkg_field_is,pkg-trig-explicit,Triggers-Awaited,)
	$(DPKG_CONFIGURE) --no-triggers pkg-trig-explicit
	$(call pkg_is_installed,pkg-trig-explicit)
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(DPKG_CONFIGURE) --pending
	$(call pkg_is_installed,pkg-triggers)
	test -f "$(DPKG_INSTDIR)/a-trigger-ok" && $(BEROOT) rm -f "$(DPKG_INSTDIR)/a-trigger-ok"
	# Verify the trigger is activated on each status change
	$(DPKG_UNPACK) --no-triggers pkg-trig-explicit.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_status_is,pkg-trig-explicit,install ok unpacked)
	$(call pkg_field_is,pkg-trig-explicit,Triggers-Awaited,)
	$(BEROOT) $(DPKG) --triggers-only pkg-triggers
	$(call pkg_is_installed,pkg-triggers)
	test -f "$(DPKG_INSTDIR)/a-trigger-ok" && $(BEROOT) rm -f "$(DPKG_INSTDIR)/a-trigger-ok"
	$(DPKG_CONFIGURE) --no-triggers pkg-trig-explicit
	$(call pkg_is_installed,pkg-trig-explicit)
	$(call pkg_field_is,pkg-trig-explicit,Triggers-Awaited,)
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(BEROOT) $(DPKG) --triggers-only pkg-triggers
	$(call pkg_is_installed,pkg-triggers)
	# Cleanup
	$(DPKG_PURGE) pkg-triggers
	$(DPKG_PURGE) pkg-trig-explicit

test-trigger-cmd test-trigger-await-cmd:
	if [ "$@" = "test-trigger-await-cmd" ]; then \
	  $(BEROOT) touch "$(DPKG_INSTDIR)/trigger-await"; \
	fi
	$(DPKG_UNPACK) pkg-triggers.deb
	$(BEROOT) rm -f "$(DPKG_INSTDIR)/a-trigger-ok" "$(DPKG_INSTDIR)/triggers/ok"
	# When unpacked, triggers are not active
	$(BEROOT) touch "$(DPKG_INSTDIR)/trigger-postinst" "$(DPKG_INSTDIR)/trigger-preinst" "$(DPKG_INSTDIR)/trigger-postrm" "$(DPKG_INSTDIR)/trigger-prerm"
	$(DPKG_INSTALL) --no-triggers pkg-trig-cmd.deb
	$(call pkg_is_installed,pkg-trig-cmd)
	$(call pkg_status_is,pkg-triggers,install ok unpacked)
	$(call pkg_field_is,pkg-triggers,Triggers-Pending,)
	! test -f "$(DPKG_INSTDIR)/a-trigger-ok"
	$(DPKG_CONFIGURE) --no-triggers pkg-triggers
	$(call pkg_is_installed,pkg-triggers)
	! test -f "$(DPKG_INSTDIR)/a-trigger-ok"
	# When installed, triggers can be activated
	$(DPKG_INSTALL) --no-triggers pkg-trig-cmd.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_field_is,pkg-triggers,Triggers-Pending, a-trigger)
	$(call pkg_status_is,pkg-trig-cmd,install ok triggers-awaited)
	$(BEROOT) $(DPKG) --triggers-only pkg-triggers

=== debian/changelog ===
dpkg (1.22.18ubuntu2) plucky; urgency=medium

  * dpkg-dev: Still prefer gnupg and gpgv over sq.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 20 Mar 2025 16:58:38 +0100

## dpkg 1.22.18ubuntu2.2

=== tests/t-conffile-prompt/Makefile ===
TESTS_DEB := pkg-conff-prompt-0 pkg-conff-prompt-1

include ../Test.mk

build-hook:
	touch "pkg-conff-prompt-0/test-conffile with spaces"
	touch "pkg-conff-prompt-1/test-conffile with spaces"

clean-hook:
	$(RM) "pkg-conff-prompt-0/test-conffile with spaces"
	$(RM) "pkg-conff-prompt-1/test-conffile with spaces"

test-case:
	$(DPKG_INSTALL) pkg-conff-prompt-0.deb
	# test if package prompts on install
	$(DPKG_INSTALL) pkg-conff-prompt-1.deb

test-clean:
	$(DPKG_PURGE) pkg-conff-prompt

=== tests/t-conffile-rename/Makefile ===
TESTS_DEB := pkg-conff-rename-0 pkg-conff-rename-1

include ../Test.mk

test-case:
	$(DPKG_INSTALL) pkg-conff-rename-0.deb
	$(DPKG_INSTALL) pkg-conff-rename-1.deb
	test -f '$(DPKG_INSTDIR)/test-conffile-new'
	test ! -f '$(DPKG_INSTDIR)/test-conffile-old'
	test ! -f '$(DPKG_INSTDIR)/test-conffile-old.dpkg-remove'
	test ! -f '$(DPKG_INSTDIR)/test-conffile-old.dpkg-bak'
	$(DPKG_PURGE) pkg-conff-rename
	# Same upgrade but with modified conffile, should still not prompt
	$(DPKG_INSTALL) pkg-conff-rename-0.deb
	$(BEROOT) sh -c "echo foo >>'$(DPKG_INSTDIR)/test-conffile-old'"
	$(DPKG_INSTALL) pkg-conff-rename-1.deb
	test -f '$(DPKG_INSTDIR)/test-conffile-new'
	test ! -f '$(DPKG_INSTDIR)/test-conffile-old'
	test ! -f '$(DPKG_INSTDIR)/test-conffile-old.dpkg-remove'
	test ! -f '$(DPKG_INSTDIR)/test-conffile-old.dpkg-bak'
	$(DPKG_PURGE) pkg-conff-rename
	# Abort-upgrade restores the to-be-renamed conffile
	$(DPKG_INSTALL) pkg-conff-rename-0.deb
	$(BEROOT) touch '$(DPKG_INSTDIR)/fail-preinst'
	$(DPKG_INSTALL) pkg-conff-rename-1.deb || true
	$(BEROOT) rm -f '$(DPKG_INSTDIR)/fail-preinst'
	test -f '$(DPKG_INSTDIR)/test-conffile-old'
	test ! -f '$(DPKG_INSTDIR)/test-conffile-new'
	test ! -f '$(DPKG_INSTDIR)/test-conffile-old.dpkg-remove'
	test ! -f '$(DPKG_INSTDIR)/test-conffile-old.dpkg-bak'
	$(DPKG_PURGE) pkg-conff-rename

test-clean:

=== tests/t-conffile-replaces-downgrade/Makefile ===
TESTS_DEB := pkg-conff-original-0 pkg-conff-original-1 pkg-conff-takeover

include ../Test.mk

define VERIFY
$(call pkg_is_installed,pkg-conff-original)
$(call pkg_is_installed,pkg-conff-takeover)
test "`$(DPKG_QUERY) -S /test-conffile`" = "pkg-conff-takeover: /test-conffile"
cmp ref-conffile "$(DPKG_INSTDIR)/test-conffile"
endef

test-case:
	# Install packages
	$(DPKG_INSTALL) pkg-conff-original-1.deb
	$(DPKG_INSTALL) pkg-conff-takeover.deb
	# Downgrade to test versioned Replaces
	$(DPKG_INSTALL) pkg-conff-original-0.deb
	$(VERIFY)
	$(DPKG_PURGE) pkg-conff-original pkg-conff-takeover

=== tests/t-dir-leftover-conffile/Makefile ===
TESTS_DEB := pkg-dir-leftover-conffile

include ../Test.mk

test-case:
	$(DPKG_INSTALL) pkg-dir-leftover-conffile.deb
	$(DPKG_REMOVE) pkg-dir-leftover-conffile
	$(DPKG_PURGE) pkg-dir-leftover-conffile
	test ! -d '$(DPKG_INSTDIR)/test-dir'

test-clean:
	$(DPKG_PURGE) pkg-dir-leftover-conffile
	$(BEROOT) rm -rf '$(DPKG_INSTDIR)/test-dir'

=== tests/t-triggers-depends/Makefile ===
TESTS_DEB := pkg-depended pkg-interest pkg-activate

include ../Test.mk

test-case:
	# Should pass due to satisfied dependencies.
	$(DPKG_INSTALL) pkg-depended.deb pkg-interest.deb
	$(DPKG_INSTALL) pkg-activate.deb
	$(DPKG_CONFIGURE) --pending

	# Should fail due to unsatisfied dependencies.
	$(DPKG_UNPACK) --no-triggers pkg-depended.deb
	$(DPKG_INSTALL) --no-triggers pkg-activate.deb
	! $(DPKG_CONFIGURE) pkg-interest

	# Should pass now due to satisfied dependencies.
	$(DPKG_CONFIGURE) --no-triggers pkg-depended
	$(DPKG_CONFIGURE) pkg-interest

	# Cleanup.
	$(DPKG_PURGE) pkg-trigger-a pkg-trigger-b
	$(DPKG_PURGE) pkg-depends

test-clean:
	-$(DPKG_PURGE) pkg-activate pkg-interest pkg-depended

=== tests/t-triggers-selfcycle/Makefile ===
TESTS_DEB := pkg-trigger-unpack pkg-trigger-activate

include ../Test.mk

test-case:
	# Self trigger cycles cannot happen with unpacked files.
	$(DPKG_INSTALL) pkg-trigger-unpack.deb
	$(DPKG_UNPACK) pkg-trigger-unpack.deb
	$(DPKG_CONFIGURE) pkg-trigger-unpack
	$(DPKG_CONFIGURE) --pending
	$(DPKG_PURGE) pkg-trigger-unpack

	# Self trigger cycles cannot happen with activate directives.
	$(DPKG_INSTALL) pkg-trigger-activate.deb
	$(DPKG_UNPACK) pkg-trigger-activate.deb
	$(DPKG_CONFIGURE) pkg-trigger-activate
	$(DPKG_CONFIGURE) --pending
	$(DPKG_PURGE) pkg-trigger-activate

	# Cleanup.
	$(DPKG_PURGE) pkg-trigger-unpack
	$(DPKG_PURGE) pkg-trigger-activate

test-clean:
	-$(DPKG_PURGE) pkg-trigger-unpack pkg-trigger-activate

=== tests/t-unpack-divert-hardlink/Makefile ===
PKG := pkg-hardlink

TESTS_DEB := $(PKG)

include ../Test.mk

$(PKG)/test-hardlink:
	link $(PKG)/test-file $@

build-hook: $(PKG)/test-hardlink

clean-hook:
	rm -f $(PKG)/test-hardlink

test-case:
	$(DPKG_DIVERT_ADD) /test-file
	$(DPKG_DIVERT_ADD) /test-hardlink
	# test if unpack can divert a hardlink
	$(DPKG_INSTALL) pkg-hardlink.deb
	$(call pkg_is_installed,pkg-hardlink)
	test -f '$(DPKG_INSTDIR)/test-file.distrib'
	test -f '$(DPKG_INSTDIR)/test-hardlink.distrib'
	cmp '$(DPKG_INSTDIR)/test-file.distrib' \
	    '$(DPKG_INSTDIR)/test-hardlink.distrib'
	test "`stat -c '%i' '$(DPKG_INSTDIR)/test-file.distrib'`" = \
	     "`stat -c '%i' '$(DPKG_INSTDIR)/test-hardlink.distrib'`"

test-clean:
	$(DPKG_PURGE) pkg-hardlink
	$(DPKG_DIVERT_DEL) /test-file
	$(DPKG_DIVERT_DEL) /test-hardlink

=== debian/changelog ===
dpkg (1.22.18ubuntu2.2) plucky-security; urgency=medium

  * SECURITY UPDATE:
    - Fix cleanup for control member with restricted directories.
      (LP: #2122053)
    - Fixes CVE-2025-6297

 -- Joy Latten <jmlatten@gmail.com>  Fri, 19 Sep 2025 16:25:43 +0000

=== debian/control ===
--- 
+++ 
@@ -132,8 +132,8 @@
  build-essential,
  gcc | c-compiler,
  fakeroot,
- sq | sqop | rsop | gosop | pgpainless-cli | gpg-sq | gnupg,
- sq | sqopv | rsopv | sopv | gosop | pgpainless-cli | gpgv-sq | gpgv,
+ gnupg | sq | sqop | rsop | gosop | pgpainless-cli | gpg-sq,
+ gpgv | sq | sqopv | rsopv | sopv | gosop | pgpainless-cli | gpgv-sq,
 # Used by dpkg-mergechangelogs.
  libalgorithm-merge-perl,
 Suggests:

=== scripts/t/dpkg_buildtree/src-build-api-v1/debian/control ===
Source: source-build-api-v1
Build-Depends:
 dpkg-build-api (= 1),

Package: binary
Architecture: all

=== scripts/t/dpkg_buildtree/src-rrr-no/debian/control ===
Source: source-rrr-no
Rules-Requires-Root: no

Package: binary
Architecture: all

## dpkg 1.22.18ubuntu3

=== debian/changelog ===
dpkg (1.22.18ubuntu3) questing; urgency=medium

  * Stop defaulting to -O3 on amd64.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Mon, 28 Apr 2025 18:25:25 +1200

## dpkg 1.22.18+rpi1

=== debian/changelog ===
dpkg (1.22.18+rpi1) trixie-staging; urgency=medium

  [changes brought forward from 1.20.5+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Sun, 02 Aug 2020 12:08:02 +0000]
  * Hack up Vendor.pm so it doesn't fail
    (see https://lists.debian.org/debian-dpkg/2020/08/msg00004.html )

  [changes introduce in 1.21.17+rpi1 by Peter Michael Green]
  * disable testsuite.

 -- Raspbian forward porter <root@raspbian.org>  Sat, 15 Mar 2025 01:22:00 +0000

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: dpkg
 Section: admin
 Priority: required
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
+Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
 Uploaders: Guillem Jover <guillem@debian.org>
 Homepage: https://wiki.debian.org/Teams/Dpkg
 Vcs-Browser: https://git.dpkg.org/cgit/dpkg/dpkg.git
@@ -127,13 +126,12 @@
  patch (>= 2.7),
  make,
  binutils,
- lto-disabled-list,
 Recommends:
  build-essential,
  gcc | c-compiler,
  fakeroot,
- gnupg | sq | sqop | rsop | gosop | pgpainless-cli | gpg-sq,
- gpgv | sq | sqopv | rsopv | sopv | gosop | pgpainless-cli | gpgv-sq,
+ sq | sqop | rsop | gosop | pgpainless-cli | gpg-sq | gnupg,
+ sq | sqopv | rsopv | sopv | gosop | pgpainless-cli | gpgv-sq | gpgv,
 # Used by dpkg-mergechangelogs.
  libalgorithm-merge-perl,
 Suggests:

## dpkg 1.22.19+rpi1

=== debian/changelog ===
dpkg (1.22.19+rpi1) trixie-staging; urgency=medium

  [changes brought forward from 1.20.5+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Sun, 02 Aug 2020 12:08:02 +0000]
  * Hack up Vendor.pm so it doesn't fail
    (see https://lists.debian.org/debian-dpkg/2020/08/msg00004.html )

  [changes introduce in 1.21.17+rpi1 by Peter Michael Green]
  * disable testsuite.

 -- Raspbian forward porter <root@raspbian.org>  Fri, 30 May 2025 08:50:09 +0000

dpkg (1.22.19) unstable; urgency=medium

  [ Guillem Jover ]
  * Perl modules:
    - Dpkg::Vendor::Debian: Add tag2upload OpenPGP keyring to package-keyrings.
    - Dpkg::Vendor::PureOS: Add new vendor module.
      Thanks to Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>.
    - Test::Dpkg: Fix OpenPGP backend commands detection.
    - Dpkg::OpenPGP::Backend::Sequoia: Add sqv support for verification.
  * Code internals:
    - libcompat: Handle allocation failures in fgetpwent() and fgetgrent().
      Based on a patch by Simon Richter <sjr@debian.org>.
  * Packaging:
    - Document OpenPGP implementation dependencies.
      Prompted by Paul Gevers <elbrus@debian.org>.
  * Localization:
    - Update Brazilian Portuguese programs translation.
      Thanks to Paulo Henrique de Lima Santana <phls@debian.org>.
      Closes: #1100999
    - Update Dutch translations.
      Thanks to Frans Spiesschaert <Frans.Spiesschaert@yucom.be>.
      Closes: #1101574, #1101582, #1101583
    - Update Portuguese translations.
      Thanks to Américo Monteiro <a_monteiro@gmx.com>.
      Closes: #1100064, #1105126
    - Update Romanian translations.
      Thanks to Remus-Gabriel Chelu <remusgabriel.chelu@disroot.org>.
      Closes: #1101549, #1101550
    - Update Swedish translations.
      Thanks to Peter Krefting <peter@softwolves.pp.se>. Closes: #1100068

 -- Guillem Jover <guillem@debian.org>  Mon, 19 May 2025 00:00:44 +0200

## dpkg 1.22.20+kali1

=== debian/changelog ===
dpkg (1.22.20+kali1) kali-dev; urgency=medium

  * Sync with Debian. Remaining changes:
    - work-around EXDEV error returned by overlayfs (cf. #836211)
    - silence the warning 'unable to delete old directory' when the directory
      is under /lib/ (cf. commit cf7b5a57)

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 10 Jun 2025 16:02:04 +0200

dpkg (1.22.20) unstable; urgency=medium

  [ Guillem Jover ]
  * Perl modules:
    - Dpkg::OpenPGP::Backend::Sequoia: Do not run sq/sqv to verify with no
      keyrings. Closes: #1106148
    - Dpkg::OpenPGP::Backend::Sequoia: Run sq in stateless mode for
      verification. Suggested by Neal H. Walfield <neal@sequoia-pgp.org>.
  * Localization:
    - Update Catalan translations.
    - Update German scripts translation.
      Thanks to Helge Kreutzmann <debian@helgefjell.de>.
    - Update Portuguese scripts translation.
    - Update Swedish scripts translation.

 -- Guillem Jover <guillem@debian.org>  Wed, 04 Jun 2025 02:12:28 +0200

dpkg (1.22.18+kali1) kali-dev; urgency=medium

  * Sync with Debian. Remaining changes:
    - work-around EXDEV error returned by overlayfs (cf. #836211)
    - silence the warning 'unable to delete old directory' when the directory
      is under /lib/ (cf. commit cf7b5a57)

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 20 Mar 2025 16:45:03 +0100

dpkg (1.22.15+kali2) kali-dev; urgency=medium

  * Revert "Work-around a perl crash during any package build"

 -- Arnaud Rebillout <arnaudr@kali.org>  Fri, 14 Feb 2025 09:07:27 +0700

dpkg (1.22.15+kali1) kali-dev; urgency=medium

  * Sync with Debian. Remaining changes:
    - work-around EXDEV error returned by overlayfs (cf. #836211)
    - work-around for perl crash (cf. commit 75631da6)
    - silence the warning 'unable to delete old directory' when the directory
      is under /lib/ (cf. commit cf7b5a57)

 -- Arnaud Rebillout <arnaudr@kali.org>  Fri, 14 Feb 2025 08:35:31 +0700

dpkg (1.22.11+kali2) kali-dev; urgency=medium

  * Silence the warning when trying to remove old dir under /lib/ (cf.
    cf7b5a57)

 -- Arnaud Rebillout <arnaudr@kali.org>  Tue, 10 Sep 2024 11:27:29 +0700

dpkg (1.22.11+kali1) kali-dev; urgency=medium

  * Sync with Debian. Remaining changes:
    - work-around EXDEV error returned by overlayfs (cf. #836211)
    - work-around for perl crash (cf. 75631da6)
    - disable merged-usr-via-aliased-dirs warning message (cf. bff5fa3c)
    - add Kali to the list of distros that don't install dpkg-fsys-usrunmess

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 04 Sep 2024 15:13:30 +0200

dpkg (1.22.6+kali1) kali-dev; urgency=medium

  * Sync with Debian. Remaining changes:
    - work-around EXDEV error returned by overlayfs (cf. #836211)
    - work-around for perl crash (cf. 75631da6)
    - disable merged-usr-via-aliased-dirs warning message (cf. bff5fa3c)
    - add Kali to the list of distros that don't install dpkg-fsys-usrunmess

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 25 Apr 2024 11:11:28 +0200

dpkg (1.22.4+kali2) kali-dev; urgency=medium

  * Add Kali to the list of distros that don't install dpkg-fsys-usrunmess

 -- Arnaud Rebillout <arnaudr@kali.org>  Mon, 29 Jan 2024 11:13:42 +0700

dpkg (1.22.4+kali1) kali-dev; urgency=medium

  * Sync with Debian. Remaining changes:
    - work-around EXDEV error returned by overlayfs (cf. #836211)
    - work-around for perl crash (cf. 75631da6)
    - disable merged-usr-via-aliased-dirs warning message (cf. bff5fa3c)

 -- Arnaud Rebillout <arnaudr@kali.org>  Mon, 29 Jan 2024 10:37:25 +0700

dpkg (1.22.2+kali1) kali-dev; urgency=medium

  * Sync with Debian. Remaining changes:
    - work-around EXDEV error returned by overlayfs (cf. #836211)
    - work-around for perl crash (cf. 75631da6)
    - disable merged-usr-via-aliased-dirs warning message (cf. bff5fa3c)

 -- Arnaud Rebillout <arnaudr@kali.org>  Tue, 02 Jan 2024 14:29:45 +0700

dpkg (1.22.1+kali1) kali-dev; urgency=medium

  * Sync with Debian. Remaining changes:
    - work-around EXDEV error returned by overlayfs (cf. #836211)
    - work-around for perl crash (cf. 75631da6)
    - disable merged-usr-via-aliased-dirs warning message (cf. bff5fa3c)

 -- Arnaud Rebillout <arnaudr@kali.org>  Fri, 24 Nov 2023 11:14:10 +0700

dpkg (1.22.0+kali1) kali-dev; urgency=medium

  * Sync with Debian. Remaining changes:
    - work-around EXDEV error returned by overlayfs (cf. #836211)
    - work-around for perl crash (cf. 75631da6)
    - Disable merged-usr-via-aliased-dirs warning message

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 01 Sep 2023 10:52:49 +0200

dpkg (1.21.22+kali1) kali-dev; urgency=medium

  * Sync with Debian. Remaining changes:
    - work-around EXDEV error returned by overlayfs (cf. #836211)
    - work-around for perl crash (cf. 75631da6)
    - Disable merged-usr-via-aliased-dirs warning message

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 15 Jun 2023 11:15:42 +0200

dpkg (1.21.21+kali2) kali-dev; urgency=medium

  * Disable merged-usr-via-aliased-dirs warning message

 -- Arnaud Rebillout <arnaudr@kali.org>  Fri, 17 Mar 2023 08:19:48 +0700

dpkg (1.21.21+kali1) kali-dev; urgency=medium

  * Sync with Debian. Remaining changes:
    - work-around EXDEV error returned by overlayfs (cf. #836211)
    - work-around for perl crash (cf. 75631da6)

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 14 Mar 2023 14:18:43 +0100

dpkg (1.21.20+kali1) kali-dev; urgency=medium

  * Sync with Debian. Remaining changes:
    - work-around EXDEV error returned by overlayfs (cf. #836211)
    - work-around for perl crash (cf. 75631da6)

 -- Arnaud Rebillout <arnaudr@kali.org>  Wed, 15 Feb 2023 09:58:03 +0700

dpkg (1.21.19+kali1) kali-dev; urgency=medium

  * Sync with Debian. Remaining changes:
    - work-around EXDEV error returned by overlayfs (cf. #836211)
    - work-around for perl crash (cf. 75631da6)

 -- Arnaud Rebillout <arnaudr@kali.org>  Tue, 31 Jan 2023 09:10:20 +0700



## dpkg 1.22.20+rpi1

=== debian/changelog ===
dpkg (1.22.20+rpi1) trixie-staging; urgency=medium

  [changes brought forward from 1.20.5+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Sun, 02 Aug 2020 12:08:02 +0000]
  * Hack up Vendor.pm so it doesn't fail
    (see https://lists.debian.org/debian-dpkg/2020/08/msg00004.html )

  [changes introduce in 1.21.17+rpi1 by Peter Michael Green]
  * disable testsuite.

 -- Raspbian forward porter <root@raspbian.org>  Thu, 19 Jun 2025 23:09:36 +0000
